diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorBar.java
index 881f9afa0..5cf479a64 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorBar.java
@@ -5,19 +5,23 @@ import net.minecraft.client.gui.ScreenHudEditor;
 import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.enums.ArmorHiddenState;
 import net.minecraft.core.enums.HumanArmorShape;
-import net.minecraft.core.enums.IArmorShape;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemArmor;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.block.ItemBlock;
 import net.minecraft.core.item.material.ArmorMaterial;
+import net.minecraft.core.util.collection.NamespaceID;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.HashMap;
@@ -25,66 +29,26 @@ import java.util.Map;
 import java.util.Random;
 
 public class HudComponentArmorBar extends HudComponentMovable {
+    private final @NotNull Random random = new Random();
+    private final @NotNull StringBuilder queryBuilder = new StringBuilder();
 
-    private final Random random = new Random();
-
-    public record CustomItemData(IArmorShape shape, String id) {}
-
-    public static final Map<IArmorShape, String> SHAPE_MAP = new HashMap<>();
-    public static final Map<ArmorMaterial, String> MATERIAL_MAP = new HashMap<>();
-    public static final Map<Item, CustomItemData> CUSTOM_ITEM_MAP = new HashMap<>();
+    public static final @NotNull Map<@NotNull Item, @NotNull NamespaceID> CUSTOM_ITEM_MAP = new HashMap<>();
+    private static final @NotNull NamespaceID ITEM_HEAD_ID = new NamespaceID("minecraft", "item_generic");
+    private static final @NotNull NamespaceID BLOCK_HEAD_ID = new NamespaceID("minecraft", "block_generic");
+    private static final @NotNull NamespaceID UNKNOWN_ID = new NamespaceID("minecraft", "unknown");
 
     static {
-        SHAPE_MAP.put(HumanArmorShape.HEAD, "helmet");
-        SHAPE_MAP.put(HumanArmorShape.CHEST, "chestplate");
-        SHAPE_MAP.put(HumanArmorShape.LEGS, "leggings");
-        SHAPE_MAP.put(HumanArmorShape.BOOTS, "boots");
-
-        MATERIAL_MAP.put(ArmorMaterial.LEATHER, "leather");
-        MATERIAL_MAP.put(ArmorMaterial.IRON, "iron");
-        MATERIAL_MAP.put(ArmorMaterial.GOLD, "gold");
-        MATERIAL_MAP.put(ArmorMaterial.CHAINMAIL, "chainmail");
-        MATERIAL_MAP.put(ArmorMaterial.DIAMOND, "diamond");
-        MATERIAL_MAP.put(ArmorMaterial.STEEL, "steel");
-
-        CUSTOM_ITEM_MAP.put(Items.ARMOR_BOOTS_ICESKATES, new CustomItemData(HumanArmorShape.BOOTS, "iceskates"));
-        CUSTOM_ITEM_MAP.put(Items.ARMOR_QUIVER, new CustomItemData(HumanArmorShape.CHEST, "quiver"));
-        CUSTOM_ITEM_MAP.put(Items.ARMOR_QUIVER_GOLD, new CustomItemData(HumanArmorShape.CHEST, "quiver_gold"));
-    }
-
-    public enum ArmorState {
-        EMPTY, HALF, FULL, INFINITE;
-
-        public String getRegistry() {
-            return this.name().toLowerCase();
-        }
-
-        public static ArmorState calculate(double currentDurability, double maxDurability) {
-            if (maxDurability <= 0) return INFINITE;
-            if (currentDurability <= 0) return EMPTY;
-
-            double durabilityPercentage = currentDurability / maxDurability;
-
-            if (durabilityPercentage > 0.50) return FULL;
-            return HALF;
-        }
-    }
-
-    private record ArmorIconKey(IArmorShape shape, ArmorState state, @Nullable ArmorMaterial material, boolean isFlipped) {}
-    private record CustomIconKey(IArmorShape shape, ArmorState state, String customId, boolean isFlipped) {}
-
-    private record ArmorPiece(IArmorShape shape, @Nullable ArmorMaterial material, @Nullable String customId, ArmorState state, double currentDurability, double maxDurability) {
-        public boolean isCustom() {
-            return customId != null;
-        }
+        CUSTOM_ITEM_MAP.put(Items.ARMOR_BOOTS_ICESKATES, new NamespaceID("minecraft", "iceskates"));
+        CUSTOM_ITEM_MAP.put(Items.ARMOR_QUIVER, new NamespaceID("minecraft", "quiver"));
+        CUSTOM_ITEM_MAP.put(Items.ARMOR_QUIVER_GOLD,  new NamespaceID("minecraft", "quiver_gold"));
     }
 
-    private final IArmorShape targetShape;
+    private record IconKey(@NotNull ArmorState state, @NotNull NamespaceID id, boolean isFlipped) {}
 
-    private final Map<ArmorIconKey, IconCoordinate> icons = new HashMap<>();
-    private final Map<CustomIconKey, IconCoordinate> customIcons = new HashMap<>();
+    private final Map<IconKey, IconCoordinate> icons = new HashMap<>();
+    private final @NotNull HumanArmorShape targetShape;
 
-    public HudComponentArmorBar(String key, Layout layout, IArmorShape targetShape) {
+    public HudComponentArmorBar(@NotNull String key, @NotNull Layout layout, @NotNull HumanArmorShape targetShape) {
         super(key, 9, 12, layout);
         this.targetShape = targetShape;
     }
@@ -98,8 +62,8 @@ public class HudComponentArmorBar extends HudComponentMovable {
             return 12;
         }
 
-        ArmorPiece piece = getWornArmorPiece();
-        if (piece == null || piece.state() == ArmorState.EMPTY) {
+        ItemStack piece = getWornArmor();
+        if (piece == null || ArmorState.calculate(piece) == ArmorState.EMPTY) {
             return 9;
         }
 
@@ -107,73 +71,67 @@ public class HudComponentArmorBar extends HudComponentMovable {
     }
 
     private boolean isFlipped() {
-        if (this.targetShape == HumanArmorShape.HEAD) return GameSettings.FLIP_HELMET_BAR.value;
-        if (this.targetShape == HumanArmorShape.CHEST) return GameSettings.FLIP_CHESTPLATE_BAR.value;
-        if (this.targetShape == HumanArmorShape.LEGS) return GameSettings.FLIP_LEGGINGS_BAR.value;
-        if (this.targetShape == HumanArmorShape.BOOTS) return GameSettings.FLIP_BOOTS_BAR.value;
-        return false;
+        return switch (this.targetShape) {
+            case HEAD -> GameSettings.FLIP_HELMET_BAR.value;
+            case CHEST -> GameSettings.FLIP_CHESTPLATE_BAR.value;
+            case LEGS -> GameSettings.FLIP_LEGGINGS_BAR.value;
+            case BOOTS -> GameSettings.FLIP_BOOTS_BAR.value;
+        };
     }
 
-    private ArmorHiddenState getHiddenState() {
-        if (this.targetShape == HumanArmorShape.HEAD) return GameSettings.HIDE_HELMET_BAR.value;
-        if (this.targetShape == HumanArmorShape.CHEST) return GameSettings.HIDE_CHESTPLATE_BAR.value;
-        if (this.targetShape == HumanArmorShape.LEGS) return GameSettings.HIDE_LEGGINGS_BAR.value;
-        if (this.targetShape == HumanArmorShape.BOOTS) return GameSettings.HIDE_BOOTS_BAR.value;
-        return ArmorHiddenState.NEVER;
+    private @NotNull ArmorHiddenState getHiddenState() {
+        return switch (this.targetShape) {
+            case HEAD -> GameSettings.HIDE_HELMET_BAR.value;
+            case CHEST -> GameSettings.HIDE_CHESTPLATE_BAR.value;
+            case LEGS -> GameSettings.HIDE_LEGGINGS_BAR.value;
+            case BOOTS -> GameSettings.HIDE_BOOTS_BAR.value;
+        };
     }
 
-    private IconCoordinate getIconForState(ArmorPiece piece, boolean isFlipped) {
-        if (piece.isCustom()) {
-            CustomIconKey key = new CustomIconKey(piece.shape(), piece.state(), piece.customId(), isFlipped);
-            return customIcons.computeIfAbsent(key, this::loadCustomIcon);
+    private @NotNull IconCoordinate getIconForState(@NotNull ArmorState state, @Nullable ArmorMaterial material, @Nullable NamespaceID customId, boolean isFlipped) {
+        NamespaceID id;
+        if (customId != null) {
+            id = customId;
+        } else if (material != null) {
+            id = material.identifier;
         } else {
-            ArmorMaterial fetchMaterial = (piece.state() == ArmorState.EMPTY) ? null : piece.material();
-            ArmorIconKey key = new ArmorIconKey(piece.shape(), piece.state(), fetchMaterial, isFlipped);
-            return icons.computeIfAbsent(key, this::loadArmorIcon);
+            id = UNKNOWN_ID;
         }
+        return this.icons.computeIfAbsent(new IconKey(state, id, isFlipped), this::loadArmorIcon);
     }
 
-    private IconCoordinate loadCustomIcon(CustomIconKey key) {
-        String shapeDir = SHAPE_MAP.getOrDefault(key.shape(), "unknown");
-
-        boolean applyFlip = key.isFlipped() && key.state() == ArmorState.HALF;
-        String stateDir = key.state().getRegistry() + (applyFlip ? "/flipped" : "");
-
-        String path = "minecraft:gui/hud/armor/" + shapeDir + "/" + stateDir + "/" + key.customId();
-        return TextureRegistry.getTexture(path);
-    }
-
-    private IconCoordinate loadArmorIcon(ArmorIconKey key) {
-        String shapeDir = SHAPE_MAP.getOrDefault(key.shape(), "unknown");
-
-        boolean applyFlip = key.isFlipped() && key.state() == ArmorState.HALF;
-        String stateDir = key.state().getRegistry() + (applyFlip ? "/flipped" : "");
-
+    private @NotNull IconCoordinate loadArmorIcon(@NotNull IconKey key) {
+        this.queryBuilder.setLength(0);
         if (key.state() == ArmorState.EMPTY) {
-            String path = "minecraft:gui/hud/armor/" + shapeDir + "/" + stateDir + "/empty";
-            return TextureRegistry.getTexture(path);
+            this.queryBuilder.append("minecraft:gui/hud/armor/").append(getShapeName()).append("/").append("/empty");
         } else {
-            String matDir = MATERIAL_MAP.getOrDefault(key.material(), "unknown");
-            String path = "minecraft:gui/hud/armor/" + shapeDir + "/" + stateDir + "/" + matDir;
-            return TextureRegistry.getTexture(path);
+            boolean applyFlip = key.isFlipped() && key.state() == ArmorState.HALF;
+            this.queryBuilder.append(key.id.namespace()).append(":gui/hud/armor/").append(getShapeName()).append("/").append(key.state().getRegistry());
+            if (applyFlip) this.queryBuilder.append("/flipped");
+            this.queryBuilder.append("/").append(key.id.value());
         }
+        return TextureRegistry.getTexture(this.queryBuilder.toString());
+    }
+
+    private @NotNull String getShapeName() {
+        return switch (this.targetShape) {
+            case HEAD -> "helmet";
+            case CHEST -> "chestplate";
+            case LEGS -> "leggings";
+            case BOOTS -> "boots";
+        };
     }
 
     @Override
     public boolean isVisible() {
-        ArmorHiddenState hiddenState = getHiddenState();
+        if (!GameSettings.IMMERSIVE_MODE.drawHotbar()) return false;
 
-        if (hiddenState == ArmorHiddenState.ALWAYS) {
-            return false;
-        }
-
-        if (!GameSettings.IMMERSIVE_MODE.drawHotbar()) {
-            return false;
-        }
+        ArmorHiddenState hiddenState = getHiddenState();
+        if (hiddenState == ArmorHiddenState.ALWAYS) return false;
 
         if (hiddenState == ArmorHiddenState.WHEN_NOT_WEARING) {
-            ArmorPiece piece = getWornArmorPiece();
-            return piece != null && piece.state() != ArmorState.EMPTY;
+            ItemStack armorStack;
+            return mc.thePlayer != null && (armorStack = mc.thePlayer.inventory.armorItemInSlot(this.targetShape)) != null && ArmorState.calculate(armorStack) != ArmorState.EMPTY;
         }
 
         return true;
@@ -186,10 +144,26 @@ public class HudComponentArmorBar extends HudComponentMovable {
 
     @Override
     public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
-        ArmorPiece piece = getWornArmorPiece();
-
-        if (piece == null) {
-            piece = new ArmorPiece(this.targetShape, null, null, ArmorState.EMPTY, 0, 0);
+        ItemStack armorStack = getWornArmor();
+        double currentDurability = 0;
+        double maxDurability = 0;
+        ArmorState state = ArmorState.EMPTY;
+        ArmorMaterial material = null;
+        NamespaceID customId = null;
+        if (armorStack != null) {
+            Item item = armorStack.getItem();
+            maxDurability = armorStack.getMaxDamage();
+            currentDurability = maxDurability > 0 ? maxDurability - armorStack.getItemDamageForDisplay() : 0;
+            if (CUSTOM_ITEM_MAP.containsKey(item)) {
+                customId = CUSTOM_ITEM_MAP.get(item);
+                state = ArmorState.calculate(armorStack);
+            } else if (item instanceof ItemArmor<?> armor) {
+                material = armor.getArmorMaterial();
+                state = ArmorState.calculate(armorStack);
+            } else if (this.targetShape == HumanArmorShape.HEAD) {
+                customId = (item instanceof ItemBlock) ? BLOCK_HEAD_ID : ITEM_HEAD_ID;
+                state = ArmorState.INFINITE;
+            }
         }
 
         int x = this.getLayout().getComponentX(this, xSizeScreen);
@@ -198,7 +172,7 @@ public class HudComponentArmorBar extends HudComponentMovable {
         int iconY = y;
 
         boolean inAcidWarning = mc.thePlayer != null && mc.thePlayer.shouldShowAcidVisualEffects() && mc.thePlayer.getGamemode().hasToolDurability();
-        if (piece.maxDurability() > 0 && ((piece.currentDurability() / piece.maxDurability()) <= 0.15 || inAcidWarning) && piece.state() != ArmorState.EMPTY) {
+        if (maxDurability > 0 && ((currentDurability / maxDurability) <= 0.15 || inAcidWarning) && state != ArmorState.EMPTY) {
             this.random.setSeed(hud.updateCounter * 0x4c627L + (long) this.targetShape.getSlotIndex() * 0x9e3779b9L);
             iconY += this.random.nextInt(2);
         }
@@ -208,10 +182,10 @@ public class HudComponentArmorBar extends HudComponentMovable {
 
         boolean isFlipped = this.isFlipped();
 
-        hud.drawGuiIcon(x, iconY, 9, 9, getIconForState(piece, isFlipped));
-        drawDurabilityBar(hud, x, y, piece.state(), piece.currentDurability(), piece.maxDurability(), 0xFF, isFlipped, inAcidWarning);
-
-        GLRenderer.disableState(State.BLEND);
+        TextureRegistry.guiSpriteAtlas.bind();
+        TessellatorGeneral t = GLRenderer.getTessellator();
+        t.startDrawingQuads(); hud.addGuiIconDouble(t, x, iconY, 9, 9, getIconForState(state, material, customId, isFlipped)); t.draw();
+        drawDurabilityBar(hud, x, y, state, currentDurability, maxDurability, 0xFF, isFlipped, inAcidWarning);
     }
 
     @Override
@@ -222,102 +196,113 @@ public class HudComponentArmorBar extends HudComponentMovable {
         GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
         renderTranslucency();
 
-        ArmorPiece previewPiece;
         int alpha = isPreviewTranslucent() ? 0x55 : 0xFF;
 
-        if (this.targetShape == HumanArmorShape.HEAD) {
-            previewPiece = new ArmorPiece(this.targetShape, ArmorMaterial.LEATHER, null, ArmorState.HALF, 45, 100);
-        } else if (this.targetShape == HumanArmorShape.CHEST) {
-            previewPiece = new ArmorPiece(this.targetShape, ArmorMaterial.IRON, null, ArmorState.HALF, 35, 100);
-        } else if (this.targetShape == HumanArmorShape.LEGS) {
-            previewPiece = new ArmorPiece(this.targetShape, ArmorMaterial.GOLD, null, ArmorState.HALF, 25, 100);
-        } else {
-            previewPiece = new ArmorPiece(this.targetShape, ArmorMaterial.DIAMOND, null, ArmorState.HALF, 15, 100);
+        ArmorMaterial previewMaterial;
+        int previewDurability;
+        switch (this.targetShape) {
+            case HEAD -> {
+                previewMaterial = ArmorMaterial.LEATHER;
+                previewDurability = 45;
+            }
+            case CHEST -> {
+                previewMaterial = ArmorMaterial.IRON;
+                previewDurability = 35;
+            }
+            case LEGS -> {
+                previewMaterial = ArmorMaterial.GOLD;
+                previewDurability = 25;
+            }
+            default-> {
+                previewMaterial = ArmorMaterial.DIAMOND;
+                previewDurability = 15;
+            }
         }
 
         boolean isFlipped = this.isFlipped();
 
-        gui.drawGuiIcon(x, y, 9, 9, getIconForState(previewPiece, isFlipped));
-        drawDurabilityBar(gui, x, y, previewPiece.state(), previewPiece.currentDurability(), previewPiece.maxDurability(), alpha, isFlipped, false);
-
-        GLRenderer.disableState(State.BLEND);
+        TextureRegistry.guiSpriteAtlas.bind();
+        TessellatorGeneral t = GLRenderer.getTessellator();
+        t.startDrawingQuads(); gui.addGuiIconDouble(t, x, y, 9, 9, getIconForState(ArmorState.HALF, previewMaterial, null, isFlipped)); t.draw();
+        drawDurabilityBar(gui, x, y, ArmorState.HALF, previewDurability, 100, alpha, isFlipped, false);
     }
 
-    private void drawDurabilityBar(Gui gui, int x, int y, ArmorState state, double currentDurability, double maxDurability, int alpha, boolean isFlipped, boolean acidWarning) {
+    private void drawDurabilityBar(@NotNull Gui gui, int x, int y, ArmorState state, double currentDurability, double maxDurability, int alpha, boolean isFlipped, boolean acidWarning) {
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setShader(Shaders.COLOR);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+
+        TessellatorGeneral tess = GLRenderer.getTessellator();
+        tess.startDrawingQuads();
+
         int barMaxWidth = 9;
         int barY = y + 10;
 
         int a = alpha << 24;
 
-        gui.drawRect(x, barY, x + 9, barY + 2, a);
+        gui.drawRect(tess, x, barY, x + 9, barY + 2, a);
 
         if (state == ArmorState.INFINITE) {
             int magentaColor = (0xFFFF00FF & 0x00FFFFFF) | a;
-            gui.drawRect(x, barY, x + barMaxWidth, barY + 1, magentaColor);
-            return;
-        }
-
-        if (maxDurability <= 0) barMaxWidth = 8;
+            gui.drawRect(tess, x, barY, x + barMaxWidth, barY + 1, magentaColor);
+        } else {
+            if (maxDurability <= 0) barMaxWidth = 8;
 
-        int barWidth = (int) Math.round((currentDurability / maxDurability) * barMaxWidth);
-        int progress = (int) Math.round((currentDurability / maxDurability) * 255D);
+            int barWidth = (int) Math.round((currentDurability / maxDurability) * barMaxWidth);
+            int progress = (int) Math.round((currentDurability / maxDurability) * 255D);
 
-        int colorFG;
-        int colorBG;
-        if (acidWarning) {
-            float t = progress / 255F;
-            colorFG = java.awt.Color.HSBtoRGB(0.11F + t * 0.06F, 1f, 1f);
-            colorBG = java.awt.Color.HSBtoRGB(0.11F, 1f, 0.35f);
-        } else {
-            colorFG = java.awt.Color.HSBtoRGB(progress / 255F / 3F, 1f, 1f);
-            colorBG = ((0xFF - progress) / 4) << 16 | 0x3f00;
-        }
+            int colorFG;
+            int colorBG;
+            if (acidWarning) {
+                float t = progress / 255F;
+                colorFG = java.awt.Color.HSBtoRGB(0.11F + t * 0.06F, 1f, 1f);
+                colorBG = java.awt.Color.HSBtoRGB(0.11F, 1f, 0.35f);
+            } else {
+                colorFG = java.awt.Color.HSBtoRGB(progress / 255F / 3F, 1f, 1f);
+                colorBG = ((0xFF - progress) / 4) << 16 | 0x3f00;
+            }
 
-        colorFG = (colorFG & 0x00FFFFFF) | a;
-        colorBG = (colorBG & 0x00FFFFFF) | a;
+            colorFG = (colorFG & 0x00FFFFFF) | a;
+            colorBG = (colorBG & 0x00FFFFFF) | a;
 
-        gui.drawRect(x, barY, x + barMaxWidth, barY + 1, colorBG);
+            gui.drawRect(tess, x, barY, x + barMaxWidth, barY + 1, colorBG);
 
-        if (barWidth > 0) {
-            if (isFlipped) {
-                int startX = x + barMaxWidth - barWidth;
-                gui.drawRect(startX, barY, startX + barWidth, barY + 1, colorFG);
-            } else {
-                gui.drawRect(x, barY, x + barWidth, barY + 1, colorFG);
+            if (barWidth > 0) {
+                if (isFlipped) {
+                    int startX = x + barMaxWidth - barWidth;
+                    gui.drawRect(tess, startX, barY, startX + barWidth, barY + 1, colorFG);
+                } else {
+                    gui.drawRect(tess, x, barY, x + barWidth, barY + 1, colorFG);
+                }
             }
         }
+
+        tess.draw();
     }
 
-    private @Nullable ArmorPiece getWornArmorPiece() {
+    private @Nullable ItemStack getWornArmor() {
         if (mc.thePlayer == null) return null;
+        return mc.thePlayer.inventory.armorItemInSlot(this.targetShape);
+    }
 
-        for (ItemStack itemStack : mc.thePlayer.inventory.armorInventory) {
-            if (itemStack == null) continue;
-
-            Item item = itemStack.getItem();
+    public enum ArmorState {
+        EMPTY, HALF, FULL, INFINITE;
 
-            if (CUSTOM_ITEM_MAP.containsKey(item)) {
-                CustomItemData data = CUSTOM_ITEM_MAP.get(item);
-                if (data.shape() == this.targetShape) {
-                    double maxDurability = itemStack.getMaxDamage();
-                    double currentDurability = maxDurability > 0 ? maxDurability - itemStack.getItemDamageForDisplay() : 0;
-                    ArmorState state = ArmorState.calculate(currentDurability, maxDurability);
-                    return new ArmorPiece(this.targetShape, null, data.id(), state, currentDurability, maxDurability);
-                }
-            } else if (item instanceof ItemArmor<?> armor) {
-                if (armor.getArmorShape() == this.targetShape) {
-                    ArmorMaterial material = armor.getArmorMaterial();
-                    double maxDurability = itemStack.getMaxDamage();
-                    double currentDurability = maxDurability > 0 ? maxDurability - itemStack.getItemDamageForDisplay() : 0;
-                    ArmorState state = ArmorState.calculate(currentDurability, maxDurability);
-                    return new ArmorPiece(this.targetShape, material, null, state, currentDurability, maxDurability);
-                }
-            } else if (this.targetShape == HumanArmorShape.HEAD) {
-                String customId = (item instanceof ItemBlock) ? "block_generic" : "item_generic";
-                return new ArmorPiece(this.targetShape, null, customId, ArmorState.INFINITE, 0, 0);
-            }
+        public @NotNull String getRegistry() {
+            return this.name().toLowerCase();
         }
 
-        return null;
+        public static @NotNull ArmorState calculate(@NotNull ItemStack armorStack) {
+            int maxDurability = armorStack.getMaxDamage();
+            if (maxDurability <= 0) return INFINITE;
+
+            int currentDurability = maxDurability - armorStack.getItemDamageForDisplay();
+            if (currentDurability <= 0) return EMPTY;
+
+            float durabilityPercentage = (float) currentDurability / maxDurability;
+            if (durabilityPercentage > 0.5f) return FULL;
+
+            return HALF;
+        }
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
index 9c5fcec2e..14d94a685 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
@@ -11,6 +11,7 @@ import net.minecraft.client.render.item.model.ItemModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Blocks;
@@ -201,23 +202,30 @@ public class HudComponentHotbar extends HudComponentMovable {
         Lighting.disable();
     }
 
-    private void drawOrientedBackgrounds(Gui gui, int x, int y, int selectedHotbar, int currentSlotIndex, boolean isLocked, boolean isVertical) {
+    private void drawOrientedBackgrounds(@NotNull Gui gui, int x, int y, int selectedHotbar, int currentSlotIndex, boolean isLocked, boolean isVertical) {
         IconCoordinate selectorDots = TextureRegistry.getTexture("minecraft:gui/hud/hotbar_selector" + selectedHotbar);
         String selTexture = "minecraft:gui/hud/hotbar_selection" + (isLocked ? "_locked" : "");
 
+        TessellatorGeneral t = GLRenderer.getTessellator();
+        TextureRegistry.guiSpriteAtlas.bind();
+
         //Uses OpenGL matrix rotation to draw the horizontal hotbar vertically
         if (isVertical) {
             GLRenderer.pushFrame();
             GLRenderer.modelM4f().translate(x + 22, y, 0);
             GLRenderer.modelM4f().rotate((float) Math.toRadians(90), 0.0f, 0.0f, 1.0f);
-            gui.drawGuiIcon(5, 0, 182, 22, TextureRegistry.getTexture("minecraft:gui/hud/hotbar"));
-            gui.drawGuiIcon(0, 0, 6, 22, selectorDots);
-            gui.drawGuiIcon(4 + currentSlotIndex * 20, -1, 24, 24, TextureRegistry.getTexture(selTexture));
+            t.startDrawingQuads();
+            gui.addGuiIconDouble(t,5, 0, 182, 22, TextureRegistry.getTexture("minecraft:gui/hud/hotbar"));
+            gui.addGuiIconDouble(t,0, 0, 6, 22, selectorDots);
+            gui.addGuiIconDouble(t,4 + currentSlotIndex * 20, -1, 24, 24, TextureRegistry.getTexture(selTexture));
+            t.draw();
             GLRenderer.popFrame();
         } else {
-            gui.drawGuiIcon(x + 5, y, 182, 22, TextureRegistry.getTexture("minecraft:gui/hud/hotbar"));
-            gui.drawGuiIcon(x, y, 6, 22, selectorDots);
-            gui.drawGuiIcon((x + 4) + currentSlotIndex * 20, y - 1, 24, 24, TextureRegistry.getTexture(selTexture));
+            t.startDrawingQuads();
+            gui.addGuiIconDouble(t,x + 5, y, 182, 22, TextureRegistry.getTexture("minecraft:gui/hud/hotbar"));
+            gui.addGuiIconDouble(t,x, y, 6, 22, selectorDots);
+            gui.addGuiIconDouble(t,(x + 4) + currentSlotIndex * 20, y - 1, 24, 24, TextureRegistry.getTexture(selTexture));
+            t.draw();
         }
     }
 
